/* Auto-generated by genmsg_cpp for file /home/east/ros_workspace/TestNode/srv/Hello.srv */
#ifndef TESTNODE_SERVICE_HELLO_H
#define TESTNODE_SERVICE_HELLO_H
#include <string>
#include <vector>
#include <map>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/time.h"

#include "ros/macros.h"

#include "ros/assert.h"

#include "ros/service_traits.h"




namespace TestNode
{
template <class ContainerAllocator>
struct HelloRequest_ {
  typedef HelloRequest_<ContainerAllocator> Type;

  HelloRequest_()
  : messages()
  {
  }

  HelloRequest_(const ContainerAllocator& _alloc)
  : messages(_alloc)
  {
  }

  typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _messages_type;
  std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  messages;


  typedef boost::shared_ptr< ::TestNode::HelloRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::HelloRequest_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct HelloRequest
typedef  ::TestNode::HelloRequest_<std::allocator<void> > HelloRequest;

typedef boost::shared_ptr< ::TestNode::HelloRequest> HelloRequestPtr;
typedef boost::shared_ptr< ::TestNode::HelloRequest const> HelloRequestConstPtr;


template <class ContainerAllocator>
struct HelloResponse_ {
  typedef HelloResponse_<ContainerAllocator> Type;

  HelloResponse_()
  : echoes()
  {
  }

  HelloResponse_(const ContainerAllocator& _alloc)
  : echoes(_alloc)
  {
  }

  typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _echoes_type;
  std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  echoes;


  typedef boost::shared_ptr< ::TestNode::HelloResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::TestNode::HelloResponse_<ContainerAllocator>  const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;
}; // struct HelloResponse
typedef  ::TestNode::HelloResponse_<std::allocator<void> > HelloResponse;

typedef boost::shared_ptr< ::TestNode::HelloResponse> HelloResponsePtr;
typedef boost::shared_ptr< ::TestNode::HelloResponse const> HelloResponseConstPtr;

struct Hello
{

typedef HelloRequest Request;
typedef HelloResponse Response;
Request request;
Response response;

typedef Request RequestType;
typedef Response ResponseType;
}; // struct Hello
} // namespace TestNode

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::HelloRequest_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::HelloRequest_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::HelloRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "cb02a4639453819d29ee2d7ed47e40d7";
  }

  static const char* value(const  ::TestNode::HelloRequest_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xcb02a4639453819dULL;
  static const uint64_t static_value2 = 0x29ee2d7ed47e40d7ULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::HelloRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/HelloRequest";
  }

  static const char* value(const  ::TestNode::HelloRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::HelloRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "string[] messages\n\
\n\
";
  }

  static const char* value(const  ::TestNode::HelloRequest_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros


namespace ros
{
namespace message_traits
{
template<class ContainerAllocator> struct IsMessage< ::TestNode::HelloResponse_<ContainerAllocator> > : public TrueType {};
template<class ContainerAllocator> struct IsMessage< ::TestNode::HelloResponse_<ContainerAllocator>  const> : public TrueType {};
template<class ContainerAllocator>
struct MD5Sum< ::TestNode::HelloResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "16f6cfe1c9764744855f9a3ea05a56e5";
  }

  static const char* value(const  ::TestNode::HelloResponse_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x16f6cfe1c9764744ULL;
  static const uint64_t static_value2 = 0x855f9a3ea05a56e5ULL;
};

template<class ContainerAllocator>
struct DataType< ::TestNode::HelloResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/HelloResponse";
  }

  static const char* value(const  ::TestNode::HelloResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::TestNode::HelloResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "string[] echoes\n\
\n\
\n\
";
  }

  static const char* value(const  ::TestNode::HelloResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::HelloRequest_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.messages);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct HelloRequest_
} // namespace serialization
} // namespace ros


namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::TestNode::HelloResponse_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.echoes);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct HelloResponse_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace service_traits
{
template<>
struct MD5Sum<TestNode::Hello> {
  static const char* value() 
  {
    return "7037d93d7515bd4d1c04b63569c667c3";
  }

  static const char* value(const TestNode::Hello&) { return value(); } 
};

template<>
struct DataType<TestNode::Hello> {
  static const char* value() 
  {
    return "TestNode/Hello";
  }

  static const char* value(const TestNode::Hello&) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::HelloRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "7037d93d7515bd4d1c04b63569c667c3";
  }

  static const char* value(const TestNode::HelloRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::HelloRequest_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Hello";
  }

  static const char* value(const TestNode::HelloRequest_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct MD5Sum<TestNode::HelloResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "7037d93d7515bd4d1c04b63569c667c3";
  }

  static const char* value(const TestNode::HelloResponse_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct DataType<TestNode::HelloResponse_<ContainerAllocator> > {
  static const char* value() 
  {
    return "TestNode/Hello";
  }

  static const char* value(const TestNode::HelloResponse_<ContainerAllocator> &) { return value(); } 
};

} // namespace service_traits
} // namespace ros

#endif // TESTNODE_SERVICE_HELLO_H

